open (FI,"<data.db");
open (FO,">appendix_hotkeys.xml");

$icons->{1} = "b3ds.png";
$icons->{2} = "bIpos.png";
$icons->{3} = "bSeqs.png";
$icons->{4} = "bImas.png";
$icons->{5} = "TextEdit.png";
$icons->{6} = "kObj.png";
$icons->{7} = "kMesh.png";
$icons->{8} = "kOM.png";
$icons->{9} = "Pose.png";
$icons->{10} = "ObOrient.png";
$icons->{11} = "Render.png";

$where->{1} = "bSel.png";
$where->{2} = "bTri.png";
$where->{3} = "bKeySel.png";
$where->{4} = "bSeqSel.png";
$where->{5} = "bButs.png";
$where->{6} = "bSelMesh.png";
$where->{7} = "bCurve.png";
$where->{8} = "bIpoSel.png";
$where->{9} = "Render.png";
$where->{10} = "armSel.png";
$where->{11} = "bImas.png";
$where->{12} = "kOM.png";

$where->{20} = "kPop.png";
$where->{21} = "kAdd.png";
$where->{22} = "bFile.png";
$where->{23} = "mL.png";
$where->{24} = "mR.png";

print FO "<!-- Appendix: Hotkeys -->\n";
print FO "<appendix id='appendix_hotkeys'>\n";
print FO "	<title>Referencias de Atajos (Teclas Calientes)</title>\n";

print FO "<para>Este Apndice es un fichero automtico de un trabajo original de Joeri Kassenaar, reorganizado ";
print FO "como una base de texto por Bastian Salmela.</para>\n";

print FO "  <section><title>Smbolos</title>\n";
print FO "<informaltable frame='all'>\n".
         "<tgroup cols='6' align='left' colsep='1' rowsep='1'>\n".
	  "<colspec colname='c1' colwidth='0.3in'/>\n".
	  "<colspec colname='c2' colwidth='1.2in'/>\n".
	  "<colspec colname='c3' colwidth='0.3in'/>\n".
	  "<colspec colname='c4' colwidth='1.2in'/>\n".
	  "<colspec colname='c5' colwidth='0.3in'/>\n".
	  "<colspec colname='c6' colwidth='1.2in'/>\n".
	  "<thead><row>\n".
          "<entry namest=\"c1\" nameend=\"c2\" align=\"center\">Funciona en</entry>\n".
          "<entry namest=\"c3\" nameend=\"c4\" align=\"center\">Funciona si</entry>\n".
          "<entry namest=\"c5\" nameend=\"c6\" align=\"center\">Produce</entry>\n".
          "</row></thead><tbody>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{1}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Ventana 3D</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{1}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Un Objeto est seleccionado</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{20}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Va a aparecer un Menu</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{2}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Ventana IPO</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{2}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>El Vrtice(s) est(n) seleccionado</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{21}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Aparecer una Caja de Herramientas</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{2}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Ventana de Secuencia</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{3}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Las claves IPO estn seleccionadas</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{22}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Un Dilogo de Seleccin de Fichero</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{4}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Ventana de Seleccin de Imagen</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{4}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Est seleccionada la Tira de la Secuencia</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para>Aparecer un Men</para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{5}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Ventana de Edicin de Texto</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{5}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Estar sobre una Ventana Botn</para></entry>\n";
print FO  "<entry namest=\"c5\" nameend=\"c6\" align=\"center\">";
print FO  "<para><command>Usos</command></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{6}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Modo Objeto</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{6}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Datos Seleccionados</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{23}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para><keycap>LMB(Botn izquierdo del ratn)</keycap></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{7}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Modos de Edicin</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{7}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Seleccionada una Curva</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{24}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para><keycap>LMB</keycap></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{8}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Modos de Edicin o de Objeto</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{8}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Manejadores IPO seleccionados</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{9}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Modo Pose</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{9}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Existe una Ventana de Render</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{10}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Ventana Orientada a Objeto</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{10}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Est seleccionada una Armadura</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$icons->{11}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Ventana de Render</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{11}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>Est seleccionado un Objeto, Existe una Ventana de Seleccin de Imagen</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO  "<row><entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<guiicon><inlinegraphic fileref=\"PartAP/hotkeys/gfx/".$where->{12}."\"></inlinegraphic></guiicon>";
print FO  "</entry>\n<entry><para>En Modo Objeto</para></entry>\n";
print FO  "<entry align=\"center\">";
print FO  "<para></para>";
print FO  "</entry>\n<entry><para></para></entry>\n</row>\n";

print FO "  </tbody></tgroup></informaltable></section>\n\n\n";

$intable=0;
while(<FI>) {
  chomp();
  s/\&/\&amp;/;
  if (/^\[(.*)\]/) {
    print FO "  <section><title>$1</title>\n";
    print FO "<informaltable frame='all'>\n".
          "<tgroup cols='4' align='left' colsep='1' rowsep='1'>\n".
	  "<colspec colname='c1'/>\n".
	  "<colspec colname='c2'/>\n".
	  "<colspec colname='c3'/>\n".
	  "<colspec colname='c4'/>\n".
	  "<thead><row>\n".
          "<entry align=\"center\">Tecla</entry>\n".
          "<entry align=\"center\">Trabaja en</entry>\n".
          "<entry align=\"center\">Acccin</entry>\n".
          "<entry align=\"center\">Trabaja si</entry>\n".
	  "</row></thead><tbody>\n";
    $intable = 1;
  } else {
    if (length($_)<2) {
      if ($intable==1) {
	print FO "  </tbody></tgroup></informaltable></section>\n\n\n";
	$intable=0;
      }
    } else {
      ($K,$on,$desc,$req) = split(/\|/);
      $K =~ s/a/ALT/;
      $K =~ s/c/CTRL/;
      $K =~ s/s/SHIFT/;
      $K =~ s/\[lmb\]/LMB/;
      $K =~ s/\[rmb\]/RMB/;
      $K =~ s/\[mmb\]/MMB/;
      if (length($K)==1) {
	$K = $K."KEY";
      }
      print FO "<row><entry align=\"center\"><keycap>$K</keycap></entry>\n";
      $on =~ s/ //g;
      @icons = split(/\,/,$on);
      print FO "<entry align=\"center\">";
      foreach $i (@icons) {
	print FO "<guiicon>".
	  "<inlinegraphic fileref=\"PartAP/hotkeys/gfx/".
	    $icons->{$i}.
	      "\"></inlinegraphic></guiicon>";
      }
      print FO "</entry>\n";
      print FO "<entry align=\"center\"><para>$desc</para></entry>\n";
      $req =~ s/ //g;
      @icons = split(/\,/,$req);
      print FO "<entry align=\"center\">";
      foreach $i (@icons) {
	print FO "<guiicon>".
	  "<inlinegraphic fileref=\"PartAP/hotkeys/gfx/".
	    $where->{$i}.
	      "\"></inlinegraphic></guiicon>";
      }
      print FO "</entry></row>\n";
    }
  }
}

print FO "</tbody></tgroup></informaltable></section>";
print FO "</appendix>";
close(FO);
close(FI);
